package com.ejie.ab79.dao.inspecciones;

import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * OrigenesInspeccionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class OrigenesInspeccionDaoImpl implements OrigenesInspeccionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDORIGENINSPECCION", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<OrigenesInspeccion> rwMap = new RowMapper<OrigenesInspeccion>() {
		public OrigenesInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OrigenesInspeccion(resultSet.getInt("IDORIGENINSPECCION"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<OrigenesInspeccion> rwMapPK = new RowMapper<OrigenesInspeccion>() {
		public OrigenesInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OrigenesInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<OrigenesInspeccion>> rwMapJerarquia = new RowMapper<JerarquiaDto<OrigenesInspeccion>>() {
		public JerarquiaDto<OrigenesInspeccion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			OrigenesInspeccion origenesinspeccion = new OrigenesInspeccion(resultSet.getInt("IDORIGENINSPECCION"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<OrigenesInspeccion> jerarquia = new JerarquiaDto<OrigenesInspeccion>();
			jerarquia.setModel(origenesinspeccion);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @return OrigenesInspeccion
	 */
	public OrigenesInspeccion add(OrigenesInspeccion origenesinspeccion) {
		String query = "INSERT INTO ORIGENES_INSPECCION (ID_ORIGEN_INSPECCION, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?)";
		this.jdbcTemplate.update(query, origenesinspeccion.getIdOrigenInspeccion(),
				origenesinspeccion.getDescripcionCastellano(), origenesinspeccion.getDescripcionEuskera(),
				origenesinspeccion.getFechaRegistro(), origenesinspeccion.getUsuarioRegistro());
		return origenesinspeccion;
	}

	/**
	 * Updates a single row in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @return OrigenesInspeccion
	 */
	public OrigenesInspeccion update(OrigenesInspeccion origenesinspeccion) {
		String query = "UPDATE ORIGENES_INSPECCION DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_ORIGEN_INSPECCION=?";
		this.jdbcTemplate.update(query, origenesinspeccion.getDescripcionCastellano(),
				origenesinspeccion.getDescripcionEuskera(), origenesinspeccion.getFechaRegistro(),
				origenesinspeccion.getUsuarioRegistro(), origenesinspeccion.getIdOrigenInspeccion());
		return origenesinspeccion;
	}

	/**
	 * Finds a single row in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @return OrigenesInspeccion
	 */
	@Transactional(readOnly = true)
	public OrigenesInspeccion find(OrigenesInspeccion origenesinspeccion) {
		String query = "SELECT t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM ORIGENES_INSPECCION t1  WHERE t1.ID_ORIGEN_INSPECCION = ?  ";

		List<OrigenesInspeccion> origenesinspeccionList = this.jdbcTemplate.query(query, this.rwMap,
				origenesinspeccion.getIdOrigenInspeccion());
		return (OrigenesInspeccion) DataAccessUtils.uniqueResult(origenesinspeccionList);
	}

	/**
	 * Removes a single row in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @return
	 */
	public void remove(OrigenesInspeccion origenesinspeccion) {
		String query = "DELETE FROM ORIGENES_INSPECCION WHERE ID_ORIGEN_INSPECCION=?";
		this.jdbcTemplate.update(query, origenesinspeccion.getIdOrigenInspeccion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<OrigenesInspeccion> getMultiple(OrigenesInspeccion filterOrigenesInspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterOrigenesInspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, OrigenesInspeccion.class,
				params, "ID_ORIGEN_INSPECCION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<OrigenesInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<OrigenesInspeccion> findAll(OrigenesInspeccion origenesinspeccion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM ORIGENES_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(origenesinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					OrigenesInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<OrigenesInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the OrigenesInspeccion table using like.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OrigenesInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<OrigenesInspeccion> findAllLike(OrigenesInspeccion origenesinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM ORIGENES_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(origenesinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					OrigenesInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<OrigenesInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the OrigenesInspeccion table.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(OrigenesInspeccion origenesinspeccion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ORIGENES_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(origenesinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the OrigenesInspeccion table using like.
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(OrigenesInspeccion origenesinspeccion, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ORIGENES_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(origenesinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of OrigenesInspeccion selected for rup_table
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OrigenesInspeccion>>
	 */
	@Override
	public List<TableRowDto<OrigenesInspeccion>> reorderSelection(OrigenesInspeccion origenesinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ORIGENES_INSPECCION t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(origenesinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				OrigenesInspeccion.class, filterParamList, "ID_ORIGEN_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OrigenesInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            OrigenesInspeccion
	 * @param searchParams
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OrigenesInspeccion>>
	 */
	@Override
	public List<TableRowDto<OrigenesInspeccion>> search(OrigenesInspeccion filterParams,
			OrigenesInspeccion searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ORIGENES_INSPECCION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				OrigenesInspeccion.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_ORIGEN_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OrigenesInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterorigenesinspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(OrigenesInspeccion filterorigenesinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ORIGENES_INSPECCION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterorigenesinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				OrigenesInspeccion.class, query, params, "ID_ORIGEN_INSPECCION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical OrigenesInspeccion table.
	 *
	 * @param filterOrigenesInspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<OrigenesInspeccion>>
	 */
	@Override
	public List<JerarquiaDto<OrigenesInspeccion>> findAllLikeJerarquia(OrigenesInspeccion filterOrigenesInspeccion,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM ORIGENES_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ORIGENES_INSPECCION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOrigenesInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_ORIGEN_INSPECCION", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					OrigenesInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOrigenesInspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(OrigenesInspeccion filterOrigenesInspeccion,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM ORIGENES_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ORIGENES_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOrigenesInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_ORIGEN_INSPECCION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOrigenesInspeccion
	 *            OrigenesInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<OrigenesInspeccion>>
	 */
	@Override
	public List<TableRowDto<OrigenesInspeccion>> findAllChild(OrigenesInspeccion filterOrigenesInspeccion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM ORIGENES_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ORIGENES_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOrigenesInspeccion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_ORIGEN_INSPECCION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<OrigenesInspeccion>(this.rwMapPK, "ID_ORIGEN_INSPECCION"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OrigenesInspeccion entity
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(OrigenesInspeccion origenesinspeccion) {

		StringBuilder where = new StringBuilder(OrigenesInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (origenesinspeccion != null && origenesinspeccion.getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(origenesinspeccion.getIdOrigenInspeccion());
		}
		if (origenesinspeccion != null && origenesinspeccion.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(origenesinspeccion.getDescripcionCastellano());
		}
		if (origenesinspeccion != null && origenesinspeccion.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(origenesinspeccion.getDescripcionEuskera());
		}
		if (origenesinspeccion != null && origenesinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(origenesinspeccion.getFechaRegistro());
		}
		if (origenesinspeccion != null && origenesinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(origenesinspeccion.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OrigenesInspeccion entity
	 *
	 * @param origenesinspeccion
	 *            OrigenesInspeccion Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(OrigenesInspeccion origenesinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(OrigenesInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (origenesinspeccion != null && origenesinspeccion.getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(origenesinspeccion.getIdOrigenInspeccion());
		}
		if (origenesinspeccion != null && origenesinspeccion.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(origenesinspeccion.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + origenesinspeccion.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (origenesinspeccion != null && origenesinspeccion.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(origenesinspeccion.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + origenesinspeccion.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (origenesinspeccion != null && origenesinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(origenesinspeccion.getFechaRegistro());
		}
		if (origenesinspeccion != null && origenesinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(origenesinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + origenesinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
